import { HTMLProps, IndexKey } from 'web-utility';
export type DataObject = Record<string, any>;
export interface VNode {
    key?: IndexKey;
    text?: string;
    selector?: string;
    tagName?: string;
    props?: DataObject;
    style?: DataObject;
    children?: VNode[];
    node?: Node;
}
export declare class VDOMNode implements VNode {
    node: Node;
    text?: string;
    tagName?: string;
    props?: DataObject;
    style?: DataObject;
    children?: VNode[];
    static selectorOf: (tagName: string, className?: string) => string;
    get selector(): string;
    static propsMap: DataObject;
    static attrsMap: any;
    constructor(node: Node);
}
type HTMLTags = {
    [tagName in keyof HTMLElementTagNameMap]: HTMLProps<HTMLElementTagNameMap[tagName]>;
} & {
    [tagName: string]: HTMLProps<HTMLElement>;
};
declare global {
    namespace JSX {
        interface IntrinsicElements extends HTMLTags {
        }
    }
}
export declare const Fragment: ({ style, children, ...props }: VDOMNode['props'] & Pick<VDOMNode, 'style' | 'children'>) => VNode;
export {};
